# Porom
porous forum

# License
Released under [CNPLv7+](https://thufie.lain.haus/NPL.html).
Please read the [full terms](./LICENSE.md) for proper wording.

# installing & first time setup
## docker
```bash
$ docker compose up
```

- opens port 8080
- exposes `data/db` and `data/avatars` as volumes for data backup and persistence
- exposes `secrets/` as a volume so that the script won't try to perform first time setup again

make sure to run it in an interactive session the first time, because it will spit out the password to the auto-created admin account.

## manual
1. install:
   - OpenResty. instructions for linux can be found [here](https://openresty.org/en/linux-packages.html)
   - LuaJIT and Lua 5.1 (usually called `lua5.1` in package managers)
   - openssl (-dev)
   - sqlite (-dev)
   - libsodium (-dev)
   - imagemagick (-dev)
   - [LuaRocks](https://luarocks.org) (either through the guide's instructions or your package manager, whichever is newer)
2. add luarocks search dirs to path:

```bash
  # in .bashrc (or other shell equivalent)
  eval "$(luarocks --lua-version 5.1 path)"
```
3. clone repo
4. install the lua dependencies:

```bash
$ luarocks --local --lua-version 5.1 build --only-deps
```
5. run:

```bash
$ start.sh production # or 'development' or empty string
```
the script will perform some necessary first time setup (and create a hidden file in the folder to ensure it won't do so again). it will create an administrator account and print the credentials to the console; **this will only happen once**. make sure you save them somewhere. the administrator account is the only one that can promote other users to moderator.  
(note the `production` argument. if called with no arguments, `start.sh` will run in a development environment, which uses a separate database and shows more debug information.)

this app is made with the assumption that it is being reverse-proxied. as such, you may want to change the port to something other than the default `8080`. you can do that in [`config.lua`]([./config.lua]).

after the first time setup is complete, everything is ready to go. put the app behind your reverse proxy and serve it on the web. the app does not run in https by itself, but the reverse proxy can be set up to do that.

once you are able to navigate to the forum, you can log in as the administrator account. other people may also sign up, but they are not able to post until manually verified by an administrator or a moderator. the administrator can promote regular users to moderator.

# icons
the icons in the `icons/` folder are by [Gabriele Malaspina](https://www.figma.com/community/file/1136337054881623512/iconcino-v2-0-0-free-icons-cc0-1-0-license)

# credits & acknowledgements
see [THIRDPARTY.md](./THIRDPARTY.md)
